{smcl}
{* 2012-08-20}{...}
{cmd:help mlist1} (2012-08-20)
{hline}

{title:Title}

{p2colset 5 22 24 2}{...}
{p2col:{cmd:mlist1}}Revising and formattng collected matrices. 
To be updated -- incomplete and not always correct!{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 18 2}
{cmd:mlist }[{it:collect-matrix}]
{cmd:,}
[{it:options}]
{p_end}

{synoptset 20 tabbed}{...}
{synopthdr}
{synoptline}

{synopt:{it:collect-matrix}}Name of matrix with collected results. The
    matrix does not need to be created by {cmd:statsto}.
    If no name is specified, the matrix {bf:StatSto} is assumed.{p_end}

{syntab:{ul:Operations on rows and columns}}

{p 6 6}
You can rearrange, select, and rename columns or rows in
the collect matrix. Commands for columns are listed; corresponding
commands for rows begin with {bf:r} (e.g., {cmd:calpha} is {cmd:ralpha}).

{synopt:{opt calph:a}}Arrange columns by alphabetical order of the
    column names. This is done after other options in this section.
    Hence if columns are renamed with {bf:crename()} the renamed
    columns are alphabetized.
    {p_end}

{synopt:{opt cdro:p(col-list)}}Drop the columns
    in {help mlist##row-lists:col-list}.{p_end}

{synopt:{opt ckee:p(col-list)}}Keep the columns in
    {help mlist##row-lists:col-list}.{p_end}

{synopt:{opt cnum:ber}}Numbers are added to the front of the
    column names. For example, if the column is named
    {bf:x1EST} it would be renamed {bf:1_x1EST}.{p_end}

{synopt:{opt cord:er(col-list)}}Columns are reordered to match
    the {help mlist##row-lists:col-list}. Columns not in the
    list are deleted. For example, {bf:corder(1 7 5)} drops all
    columns except for 1, 5 and 7 and places these columns in
    the order 1-7-5. {help mlist##row-lists:Numbers or
    names can be used in the column list}.{p_end}

{synopt:{opt cren:ame(current-name=new-name... | list-of-new-labels)}}
    Columns are renamed. Either you can list the current name equal to
    a new name (repeating as often as you want) or you can supply a
    list of namesfor all columns.{p_end}

{syntab:{ul:Listing the collect matrix}}

{synopt:{opt coln:ames}}List the column names.{p_end}

{synopt:{opt list}}List the collect matrix. You can use this
    option along with other options or as the only option
    (e.g., {bf:mlist mymatrix, list}).{p_end}

{synopt:{opt pre:view}}Preview the changes to the collect matrix but do
    not retain the changes. This lets you check what {cmd:mlist}
    options do or lets list a matrix using the row and column
    options without modifying the original collect matrix.{p_end}

{synopt:{opt rown:ames}}List the row labels.{p_end}

{synopt:{opt title(string)}}Title used when listing matrix.{p_end}

{synopt:{opt tran:spose}}Transpose the matrix before listing. The
original matrix is not change.{p_end}

{syntab:{ul:Formatting the listed numbers}}

{synopt:{opt f:ormat(string)}}The format used for listing
    the matrix. For example, {bf:format(%10.2f)}.
    See {help format:format} for details.{p_end}

{synopt:{opt wid:th(integer)}}The column width for
    listing the matrix. For example, to
    list each column with a width of 12, {bf:width(12)}.{p_end}

{synopt:{opt dec:imals(integer)}}The number of decimal digits
    used when the matrix is listed. For example, to
    list with three digits, {bf:decimals(3)}.{p_end}

{syntab:{ul:Generating variables and saving matrices}}

{synopt:{opt gen:erate(col-list)}}Variables
    are generated from the columns in {help mlist##row-lists:col-list};
    {bf:_all} selects all columns. If the {bf:transpose} option is used,
    the matrix is transposed before generating variables. Hence
    variables are created from the rows.{p_end}

{synopt:{opt gens:tub(gstub)}}
    Variables are named {it:gstub}+{it:column-name}.
    {p_end}

{synopt:{opt save(new-matrix)}}The current matrix is saved as
    matrix {it:new-matrix}. Operations from the current {bf:mlist} command
    are completed before saving the matrix.

{title:Specifying rows or columns}

{pstd}
You can specify columns using column indices or column names.
    For example, to specify the 1st, 7th and 4th column you can use the
    column numbers: {bf:1 7 4}. Assuming the columns are named {bf:Col}{it:#},
    you can select the same columns as: {bf:Col1 Col7 Col4}. You can mix
    names and numbers: {bf:1 7 Col4}. Adjacent columns can be selected using
    a dash. For example to select columns 3 through 9 you could use any of the
    following: {bf:3-9} or {bf:Col3-Col9} or {bf:Col3-9} or {bf:3-Col9}.
    The abbreviation {bf:_all} selects all columns. The same methods can be
    used to select rows. For example, {bf:Row10 Row1 3-5 Row7-8 9-Row13}
    translates into the indices {bf:10 1 3 4 5 7 8 9 10 11 12 13}
    {p_end}

{title:Examples}

{title:References}

{phang}
XXX, X. 20xx.

{title:Authors}

{pstd}
If you use the commands, please cite them as:

{p 4 4 0}
Long and Freese...
{browse "http://www.indiana.edu/~jslsoc/":see .}
{p_end}

{title:Also see}

{psee}
Commands:  {helpb mlist:mlist}, {helpb mstore:mstore}, {helpb mpost:mpost}

{psee}
{space 2}Manual:  {manlink R regress}

{psee}
{space 4}Help:  {manhelp regress_postestimation R:regress postestimation},
{manhelp regress_postestimation_ts R:regress postestimation time series}
{p_end}

