*! version 0.1.5 2012-09-05 | long freese | names()

** list margins results matrix - to be retired

capture program drop mlist1
program define mlist1, sclass

    version 11.2

    syntax [anything(name=matoutput)] , [ ///
    ///
    /// matlist options
        names(string) /// passthrough to matlist
    ///
    ///
        blank               /// add a blank row
        CALPha RALPha        ///
        CDROp(string) RDROp(string) ///
        CKEEp(string) RKEEp(string) ///
        CNAMES RNAMES ///
        CNUMber RNUMber       ///
        CNUMBEROnly RNUMBEROnly ///
        CORDer(string)  RORDer(string) ///
        CREName(string) RREName(string) ///
        DECimals(numlist >-1 integer) /// digits when list matrix
        Format(string)      /// format for matrix
        GENerate(string)  GENStub(string) ///
        mv(string)          /// default missing value
        nolist              /// list matrix
        nocoleqnm           /// don't us in gen
        preview             /// preview changes but don't change matrix
        save(string)        /// save matrix to new matrix
        title(string)       /// title added when listing
        TRANspose ///
        WIDth(numlist >0 integer) /// width when listing matrix
        bnm(string) senm(string) znm(string) pnm(string) ///
        lbnm(string) ubnm(string) dfnm(string) critnm(string) ///
        eformnm(string) ///
     ]

    tempname matrownull matwork    mattemp

//   decode syntax

    local isall = regexm(" `names'","[ ](a|al|all)")
    local isrow = regexm(" `names'","[ ](r|ro|row|rows)")
    local isnon = regexm(" `names'","[ ](n|no|non|none)")
    local iscol = regexm(" `names'","[ ](c|co|col|colu|column|columns)")
    if "`names'"=="" | `isall' {
        local names "all"
    }
    else if `isrow' {
        local names "rows"
    }
    else if `iscol' {
        local names "columns"
    }
    else if `isnon' {
        local names "none"
    }
    else {
        display as error ///
        "invalid names() option"
    }

    local nolist "`list'"
    local list "list"
    if ("`nolist'"=="nolist") local list ""
/*
    local modify = 0
    if "`cnumber'"=="cnumber" | "`corder'"!="" | "`cdrop'"!="" ///
      |"`rnumber'"=="rnumber" | "`rorder'"!="" | "`rdrop'"!="" ///
      |"`rnumberonly'"=="rnumberonly" | "`cnumberonly'"=="cnumberonly" ///
      |"`rrename'"!="" | "`calpha'"!="" | "`ckeep'"!="" ///
      |"`crename'"!="" | "`ralpha'"!="" | "`rkeep'"!="" {
        local modify = 1
    }
*/

    local iserror = 0

    if "`rnumber'"=="rnumber" & "`rnumberonly'"=="rnumberonly" {
        display as error ///
        "rnumber and rnumberonly cannot be in the same command"
        local iserror = 1
    }
    if "`cnumber'"=="cnumber" & "`cnumberonly'"=="cnumberonly" {
        display as error ///
        "cnumber and cnumberonly cannot be in the same command"
        local iserror = 1
    }
    if "`corder'"!="" & "`cdrop'"!="" {
        display as error ///
        "corder() and cdrop() cannot be in the same command"
        local iserror = 1
    }
    if "`rorder'"!="" & "`rdrop'"!="" {
        display as error ///
        "rorder() and rdrop() cannot be in the same command"
        local iserror = 1
    }
    if "`corder'"!="" & "`ckeep'"!="" {
        display as error ///
        "corder() and ckeep() cannot be in the same command"
        local iserror = 1
    }
    if "`cdrop'"!="" & "`ckeep'"!="" {
        display as error ///
        "cdrop() and ckeep() cannot be in the same command"
        local iserror = 1
    }
    if "`rdrop'"!="" & "`rkeep'"!="" {
        display as error ///
        "rdrop() and rkeep() cannot be in the same command"
        local iserror = 1
    }

    if (`iserror'==1) exit

//  missing values

    local mvis "."
    if "`mv'"!="" & "`mv'"!="." {
        if length("`mv'")>1 {
            display as error ///
            "mv() must be a period or single letter"
            exit
        }
        local mv = lower("`mv'")
        local mvis ".`mv'"
    }
    local mv "`mvis'"

//  format

    if ("`decimals'"!="" | "`width'"!="") & "`format'"=="" {
        if ("`decimals'"=="") local decimals "0"
        if ("`width'"=="") local width "10"
        if (`decimals'>`width') local width = `decimals' + 1
        local format "%`width'.`decimals'f"
    }

//  set up matrices

    if ("`matoutput'"=="") local matstart "_mstore"
    else local matstart "`matoutput'"
    capture matrix list `matstart'
    if _rc ~= 0 {
        display as error ///
        "matrix `matstart' is not in memory"
        exit
    }
    matrix `matwork' = `matstart'
    local nrows = rowsof(`matwork')
    local ncols = colsof(`matwork')
    local colnms : colnames `matwork'

//  change rows and columns

    * rename
    if "`rrename'"!="" {
         RowColRename, list(`rrename') rowcol(row) matnm(`matwork')
    }
    if "`crename'"!="" {
         RowColRename, list(`crename') rowcol(col) matnm(`matwork')
    }

    * add numbers to current names
    if "`rnumber'"=="rnumber" | "`cnumber'"=="cnumber" {
        local rownms : rownames `matwork'
        local colnms : colnames `matwork'
        if "`rnumber'"=="rnumber" {
            local newrownms ""
            local i = 0
            foreach nm in `rownms' {
                local ++i
                local newrownms "`newrownms' `i'_`nm'"
            }
            matrix rownames `matwork' = `newrownms'
        }
        if "`cnumber'"=="cnumber" {
            local newcolnms ""
            local i = 0
            foreach nm in `colnms' {
                local ++i
                local newcolnms "`newcolnms' `i'_`nm'"
            }
            matrix colnames `matwork' = `newcolnms'
        }
    }

    * only keep number for row/col names
    if "`rnumberonly'"=="rnumberonly" | "`cnumberonly'"=="cnumberonly" {
        local rownms : rownames `matwork'
        local colnms : colnames `matwork'
        if "`rnumberonly'"=="rnumberonly" {
            local newrownms ""
            local i = 0
            foreach nm in `rownms' {
                local ++i
                local newrownms "`newrownms' `i'"
            }
            matrix rownames `matwork' = `newrownms'
        }
        if "`cnumberonly'"=="cnumberonly" {
            local newcolnms ""
            local i = 0
            foreach nm in `colnms' {
                local ++i
                local newcolnms "`newcolnms' `i'"
            }
            matrix colnames `matwork' = `newcolnms'
        }
    }

    * drop rows
    if "`rdrop'"!="" {
        DecodeRClist, rclist(`rdrop') matnm(`matwork') rowcol(row)
        local dropindex `s(rcindex)'
        local error = s(error)
        if (`error'==1) exit
        DecodeRClist, rclist(_all) matnm(`matwork') rowcol(row)
        local matindex `s(rcindex)'
        local rowskeep : list matindex - dropindex
        RowReorder, order(`rowskeep') matrix(`matwork')
    }

    * drop columns
    if "`cdrop'"!="" {
        DecodeRClist, rclist(`cdrop') matnm(`matwork') rowcol(col)
        local dropindex `s(rcindex)'
        local error = s(error)
        if (`error'==1) exit
        DecodeRClist, rclist(_all) matnm(`matwork') rowcol(col)
        local matindex `s(rcindex)'
        local colskeep : list matindex - dropindex
        ColReorder, order(`colskeep') matrix(`matwork')
    }

    * keep columns
    if "`ckeep'"!="" {
        DecodeRClist, rclist(`ckeep') matnm(`matwork') rowcol(col)
        local keepindex `s(rcindex)'
        local error = s(error)
        if (`error'==1) exit
        ColReorder, order(`keepindex') matrix(`matwork')
    }

    * keep rows
    if "`rkeep'"!="" {
        DecodeRClist, rclist(`rkeep') matnm(`matwork') rowcol(row)
        local keepindex `s(rcindex)'
        local error = s(error)
        if (`error'==1) exit
        RowReorder, order(`keepindex') matrix(`matwork')
    }

    * rearrange columns
    if "`corder'"!="" {
        DecodeRClist, rclist(`corder') matnm(`matwork') rowcol(col)
        local corder `s(rcindex)'
        local error = s(error)
        if (`error'==1) exit
        ColReorder, order(`corder') matrix(`matwork')
    }

    * rearrange rows
    if "`rorder'"!="" {
        DecodeRClist, rclist(`rorder') matnm(`matwork') rowcol(row)
        local rorder `s(rcindex)'
        local error = s(error)
        if (`error'==1) exit
        RowReorder, order(`rorder') matrix(`matwork')
    }

    * alphabetize rows
    if "`ralpha'"!="" {
        local rowalpha : rownames `matwork'
        local rowalpha : list sort rowalpha
        foreach nm in `rowalpha' {
            GetRowIndex, name(`nm') matrix(`matwork')
            local matrownum `s(matrownum)'
            matrix `mattemp' = nullmat(`mattemp') \ `matwork'[`matrownum',1...]
        }
        matrix `matwork' = `mattemp'
    }

    * alpha ordering of columns
    if "`calpha'"!="" {
        local colalpha : colnames `matwork'
        local colalpha : list sort colalpha
        foreach nm in `colalpha' {
            GetColIndex, name(`nm') matrix(`matwork')
            local matcolnum `s(matcolnum)'
            matrix `mattemp' = nullmat(`mattemp') , `matwork'[1...,`matcolnum']
        }
        matrix `matwork' = `mattemp'
    }

//  add a blank row to matrix

    if "`blank'"!="" {
        local matncols = colsof(`matwork')
        matrix `matrownull' = J(1,`matncols',`mv')
        matrix rownames `matrownull' = "-"
        matrix `matwork' = (`matwork') \ (`matrownull')
    }

//  list matrix

    if "`list'"=="list" | "`preview'"=="preview" {

        ListMatrix, matprint(`matwork') matname(`matstart') ///
            `transpose' names(`names') ///
            format(`format') matrownum(`matrownum') title(`title') ///
            `preview'
    }

//  generate variables

    if "`generate'"!="" {
        local matgen "`matwork'"
        tempname mattran
        if "`transpose'"=="transpose" {
            matrix `mattran' = `matwork''
            local matgen "`mattran'"
        }

        if "`generate'"=="_all" {
            local Ncol = colsof(`matgen')
            local generate "1-`Ncol'" // _all is 1-Ncolumns
        }
        GenerateVars, gen(`generate') matnm(`matgen') stub(`genstub') ///
            `nocoleqnm'
    }

//  save matrix

    if "`save'"!="" {
        capture matrix list `save'
        if _rc==0 {
            display as error ///
            "The matrix `save' exists, so choose another name"
        }
        else {
            if ("`transpose'"=="transpose") matrix `save' = `matwork''
            else matrix `save' = `matwork'
            display as result ///
            "Matrix `save' was created"
        }
    }

//  post matrix change

    if ("`preview'"=="") matrix `matstart' = `matwork'

//  list names

    if "`cnames'"=="cnames" {
        local colnms : colnames `matstart'
        di "Column names:"
        di "`colnms'"
    }
    if "`rnames'"=="rnames" {
        local rownms : rownames `matstart'
        di "Row names:"
        di "`rownms'"
    }

    * create default sreturns
    sreturn local b `"b"'
    sreturn local se `"se"'
    sreturn local z `"b"'
    sreturn local p `"pvalue"'
    sreturn local lb `"ll"'
    sreturn local ub `"ul"'
    sreturn local df `"df"'
    sreturn local crit `"crit"'
    sreturn local eform `"eform"'

end // END of mlist

//  ColReorder: rearrange columns in a matrix
//
//  input:  matrix(name of matrix)
//          order(new column order): numbers corresponding to columns; numbers
//              larger than max column are ignored; duplicates allowed.
//  output: revised matrix with same name

program ColReorder, sclass

    syntax , matrix(string) order(string)
    tempname matnew
    local matnm "`matrix'"
    local matncols  = colsof(`matnm')
    local matcolnms : colnames `matnm'
    local NEWcolN   : word count `order'
    local NEWcolnms ""

    local isfirst = 1
    foreach icol in `order' {
        * ignore values that are too large
        if `icol'<=`matncols' {
            local nm : word `icol' of `matcolnms'
            local NEWcolnms "`NEWcolnms' `nm'"
            if `isfirst'==1 {
                matrix `matnew' = `matnm'[1...,`icol']
                local isfirst = 0
            }
            else matrix `matnew' = `matnew',`matnm'[1...,`icol']
        }
    }
    matrix `matnm' = `matnew'

end

//  RowColRename: rename rows or columns
//
//  input:   list(string)       oldname=newname... or newnames....
//           rowcol(string)    is row or col
//           matnm(string)      name of matrix
//           s(error)

program RowColRename, sclass

    syntax , list(string) rowcol(string) matnm(string)
    sreturn clear

    if "`rowcol'"=="row" {
        local nownames : rownames `matnm'
        local RCnm "row"
        local RCNm "Row"
        local RCname "row"
        local RCName "Row"
        local RCodd "rrename()"
    }
    else if "`rowcol'"=="col" {
        local nownames : colnames `matnm'
        local RCnm "col"
        local RCNm "Col"
        local RCname "column"
        local RCName "Column"
        local RCodd "crename()"
    }
    else {
        display as error "RowColRename requires rowcol(row|col)"
        sreturn local error = 1
        exit
    }

//  does list have = in it

    local list : subinstr local list "=" " = ", all
    local isEqual : list posof "=" in list
    local isEqual = `isEqual'>0

//  no equal sign

    if `isEqual'==0 {
        local listN : word count `list'
        local nowN  : word count `nownames'
        if `listN'!=`nowN' {
            display as error ///
"You must have one name for each `RCname' or have oldname=newname pairs"
            sreturn local error = 1
            exit
        }
        matrix `RCnm'names `matnm' = `list'
    }

// decode oldname=newname list

    if `isEqual'==1 {

        local list : subinstr local list "=" " ", all
        local listN : word count `list'

        local listpairsN = `listN'/2
        capture confirm integer number `listpairsN'
        if _rc>0 {
            display as error ///
        "`RCodd' using = must have matched pairs of names"
            sreturn local error = 1
            exit
        }
        * get two sets of names
        local Nminus1 = `listN'-1
        local oldnames ""
        local newnames ""
        forvalues i = 1(2)`Nminus1' {
            local oldnm : word `i' of `list'
            local j = `i' + 1
            local newnm : word `j' of `list'
            Get`RCNm'Index, name(`oldnm') matrix(`matnm')
            local rcnum `s(mat`RCnm'num)'
            if `rcnum'==0 {
                display as error ///
                "`oldnm' is not a current `RCname' name"
                sreturn local error = 1
                exit
            }
            else {
                local nownames : ///
                subinstr local nownames "`oldnm'" "`newnm'", word
            }
        }
        matrix `RCnm'names `matnm' = `nownames'
    } // has equals

    sreturn local error = 0

end

//  GetColIndex: find column number given column label
//
//  input:  name(name of column label)
//          matrix(name of matrix)
//
//  output: s(matcolnum): column number in matrix

program GetColIndex, sclass

    syntax , name(string) matrix(string)
    sreturn clear
    local matcolnms : colnames `matrix'
    local matcolnum : list posof "`name'" in matcolnms
    sreturn local matcolnum `"`matcolnum'"'

end

// GetRowIndex: find row number given row label
//
//  input:  name(name of row label)
//          matrix(name of matrix)
//
//  output: s(matrownum): row number in matrix
//          s(mataddrow): 1 if new row needed, else 0

program GetRowIndex, sclass

    syntax , name(string) matrix(string)
    sreturn clear
    local mataddrow = 1
    local matrownms : rownames `matrix'
    local mataddrow = 0
    local matrownum : list posof "`name'" in matrownms
    if (`matrownum'==0) local mataddrow = 1
    sreturn local mataddrow `"`mataddrow'"'
    sreturn local matrownum `"`matrownum'"'

end

//  GenerateVars: create variables from columns of SNAG matrix
//
//  input:  matnm(string): name of matrix
//          gen(string)  : columns to be generated
//  output: s(Gvarnames) : names of geneated variables
//          s(Gcolnames) : column names from results matrix
//          s(Gcolindex) : column indices from results matrix
//          s(error)     : 0 or 1

program GenerateVars, sclass
    syntax , matnm(string) gen(string) [ stub(string) ///
        nocoleqnm ]
    sreturn clear

    DecodeRClist, rclist("`gen'") matnm(`matnm') rowcol(col)
    local error = s(error)
    if `error'==1 {
        sreturn local error = 1
        exit
    }
    local Gcolindex `s(rcindex)'
    local Gcolnames `s(rcnames)'

    if "`stub'"!="" {
        local Gvarnames ""
        foreach nm in `Gcolnames' {
            local Gvarnames "`Gvarnames' `stub'`nm'"
        }
    }
    else local Gvarnames "`Gcolnames'"

    * temporary matrix with data to be generated
    tempname matgen
    local Nrow = rowsof("`matnm'")
    local Ncol = wordcount("`Gvarnames'")
    local cnum = 0
    foreach col in `Gcolindex' {
        local ++cnum
        matrix `matgen' = nullmat(`matgen') , `matnm'[1...,`col']
    }

    * change columns to variables names and create variables from matrix
    matname `matgen' "`Gvarnames'", col(1...) explicit
    qui svmat `matgen', names(col)
    if _rc>0 {
        display as error ///
    "svmat encountered problems with matrix `matgen'"
        local error = 1
        exit
    }

    sreturn local Gcolindex `"`Gcolindex'"'
    sreturn local Gcolnames `"`Gcolnames'"'
    sreturn local Gvarnames `"`Gvarnames'"'
    sreturn local error = `error'

end

//  DecodeRClist: decode row and columun selection
//
//  input:   rclist(string) : list of rows and columns
//           rowcol(string): row or column
//           matnm(string)  : name of matrix
//
//  output:  s(rcindex)     : index numbers of selected rows or columns
//           s(rcnames)     : names of selected rows or columns
//           s(error)       : 0 or 1
//
//  syntax of list: # name #-# name-name #-name name-#

program DecodeRClist, sclass

    syntax , rclist(string) rowcol(string) matnm(string)
    local error 0

    if "`rowcol'"!="row" & "`rowcol'"!="col" {
        display as error "rowcol() must be either row or col"
        sreturn local error = 1
        exit
    }

    local RCname "Column"
    local rcname "column"
    if "`rowcol'" == "row" {
        local RCname "Row"
        local rcname "row"
    }

    local matnames : `rowcol'names `matnm'
    local matnamesN : word count `matnames'

    if ("`rclist'"=="_all") local rclist "1-`matnamesN'"

    * make - a seperate word
    local rclist : subinstr local rclist "  " " ", all
    local rclist : subinstr local rclist "-" " - ", all
    local rclist : subinstr local rclist "  " " ", all

    local rcnames ""    // names of selected columns or rows
    local rcindex ""    // index of selected rows or columns

    * change words to numbers in list
    local numlist ""
    local wordsN : word count `rclist'
    foreach w in `rclist' {
        capture confirm integer number `w'
        if _rc==0 {
            if `w'<=`matnamesN' {
                local numlist "`numlist' `w'"
            }
            else {
                display as error ///
                "`RCname' number is too large given matrix's dimensions"
                local error =1
                continue, break
            }
        }
        else {
            local iloc : list posof "`w'" in matnames
            if (`iloc'>0) local numlist "`numlist' `iloc'"
            else if ("`w'"=="-") local numlist "`numlist' -"
            else {
                display as error "`RCname' name `w' is not in matrix"
                local error = 1
                continue, break
            }
        }
    }
    if `error'==1 {
        sreturn local error = 1
        exit
    }

// parse # and #-#

    local iword = 1
    local nextword = 1
    while `iword' <= `wordsN' {

        * note: L-R corresonds to Wleft Wminus Wright
        local Wleft : word `iword' of `numlist'
        local Wleftword = `iword'

        * get word that will be = if entery is of form a=b
        if `iword' < `wordsN' {
            local ++iword
            local Wminus : word `iword' of `numlist'
        }
        else local Wminus "dog" // it isn't minus!

        * if -, get word on right
        if "`Wminus'"=="-" {
            local nextword = `iword' + 2 // plus 2 since Wminus and Wright used
            local ++iword
            if (`iword' <= `wordsN') local Wright : word `iword' of `numlist'
            else {
                display as error "A name or value must follow - in list"
                local error =1
                continue, break
            }
            forvalues i = `Wleft'(1)`Wright' {
                local rcindex "`rcindex' `i'"
            }
        } // is - sign

        * is not - sign
        else {
            local nextword = `Wleftword' + 1 // only 1 word to specify value
            local rcindex "`rcindex' `Wleft'"
        }

        local iword = `nextword'

    } // loop through option words

    if `error'==1 {
        sreturn local error = 1
        exit
    }

    foreach i in `rcindex' {
        local nm : word `i' of `matnames'
        local rcnames "`rcnames' `nm'"
    }

    sreturn local rcindex `"`rcindex'"'
    sreturn local rcnames `"`rcnames'"'
    sreturn local error = `error'

end

//  SO RowReorder: reorder rows in a matrix
//
//  input:  matrix(name of matrix)
//          order(new row order): numbers corresponding to rows; numbers
//              larger than max row are ignored; duplicates allowed.
//
//  output: revised matrix with same name

program RowReorder, sclass

    syntax , matrix(string) order(string)
    tempname matnew
    local matnm "`matrix'"
    local matnrows  = rowsof(`matnm')
    local matrownms : rownames `matnm'
    local NEWrowN   : word count `order'
    local NEWrownms ""

    local isfirst = 1
    foreach irow in `order' {
        * ignore values that are too large
        if `irow'<=`matnrows' {
            local nm : word `irow' of `matrownms'
            local NEWrownms "`NEWrownms' `nm'"
            if `isfirst'==1 {
                matrix `matnew' = `matnm'[`irow',1...]
                local isfirst = 0
            }
            else matrix `matnew' = `matnew' \ `matnm'[`irow',1...]
        }
    }
    matrix `matnm' = `matnew'

end

program ListMatrix, sclass

    syntax , matprint(string) matname(string) ///
            [ preview transpose listnew format(string) ///
            matrownum(string) title(string) names(string) ]

    version 11.2

    tempname mattemp

    local Ltitle ""
    if "`preview'"=="preview" local Ltitle "Preview of "
    if "`listnew'"=="listnew" local Ltitle "`Ltitle'changes to "
    if "`transpose'"=="transpose" local Ltitle "`Ltitle'transposed "
    local Ltitle "`Ltitle'`matname': `title'"

    if "`list'"=="list" {
        if "`transpose'"=="transpose" {
            matrix `mattemp' = `matprint''
        }
        else {
            matrix `mattemp' = `matprint'
        }
    }

    if "`listnew'"=="listnew" {
        matrix `mattemp' = `matprint'[`matrownum',1...]
    }

    matlist `matprint', names(`names') ///
            format(`format') nohalf noheader title(`Ltitle') nodotz

end

exit

* 0.0.0 2012-08-17
* 0.0.1 2012-08-18 09.02
* 0.1.0 2012-08-19 13.59
* 0.1.1 2012-08-20 06.59 minor updates
* 0.1.2 2012-08-20 09.15 add names of generated variables
* 0.1.3 2012-08-20 12.12 major cleanup of code; runs with mgen2
* 1 bug: statout, rdrop(_all) list
* 2 bug: statout, ckeep(6-5)
* 3 nocoleqnm
* 4 coleqnm in gen
* 5 use numlist not 1-N
* 6 test each option
* version 0.1.4 2012-09-02 jsl | minor bugs | posted
    * title
