    {smcl}
{* 2012-08-19 14.40 scott long}{...}
{hi:help mstore}{right:also see: {helpb mpost}; {helpb margins}}
{hline}

{title:Store {cmd:margins} r(at) and r(table) to matrix}

{p2colset 5 16 13 2}{...}
{p2col:{cmd:mstore} {hline 2}}{cmd:mstore} collects results from
{cmd:margins} and creates a a matrix | 19Aug2012{p_end}
{p2colreset}{...}

{marker overview}
{title:Overview}

{pstd}
{cmd:margins} uses the matrix r(table) to hold predictions along with
confidence intervals and test results and uses r(at) to hold values of the
predictors associated with the predictions. {cmd:mstore} collects
information from these matrices to a new matrix allowing you to combine
information across {cmd:margins} results, generate variables from predictions
(e.g., for plotting), and 
to list the results. See {cmd:mlist} for more listing options.


{title:General syntax}

{p 4 8 2}
{cmd:mstore} [{it:your_matrix}]{cmd:,}
[
{opt at}
{opt atcol:s(numlist)}
{opt atvar:s(column-names-to-keep)}
{opt tabl:e}
{opt tabcol:s(numlist)}
{opt tabstat:s(statistics-names-to-keep)}
{opt noomit}
{opt dropcolm:iss}
{opt rows(numlist)}
{opt droprowm:iss}
{opt mv(. or letter)}
{opt blank}
{opt colstub(string)}
{opt coleq:nm(string)}
{opt out:come(string)}
{opt cnum:ber}
{opt cnumbero:nly}
{opt rowstub(string)}
{opt roweq:nm(string)}
{opt rnumb:er}
{opt rnumberonly}
{opt gen:erate(string)}
{opt gens:tub(string)}
{opt mout:come(string)}
{opt save(string)}
{opt clear}
{opt atright}
{opt atleft}
{opt wide}
{opt long}
{opt list}
{opt title(string)}
{opt preview}
{opt f:ormat(string)}
{opt wid:th(integer}
{opt dec:imals(integer)}
]

{synoptset 20 tabbed}{...}
{synopthdr}
{synoptline}

{synopt:{it:collect-matrix}}Name of matrix with collected results. The
    matrix does not need to be created by {cmd:mstore}.
    If no name is specified, the matrix {bf:_mstore_} is assumed.{p_end}

{syntab:{ul:What to store}}

{synopt:{opt clear}}Delete existing values in the collect matrix before
    collecting new values.{p_end}

{synopt:{opt at}}Save information from r(at).{p_end}

{synopt:{opt atcol:s(numeric-list)}}Numbers of columns to be stored.
For example, {cmd:atvars(1(1)10)}.{p_end}

{synopt:{opt atvar:s(column-names)}}Names of columns to be stored.
For example, .{p_end}

{synopt:{opt table}}Save information from r(table).
If neither {cmd:at} nor {cmd:table} are specfied, {cmd:table} is assumed.
    {p_end}

{synopt:{opt tabcol:s(numeric-list)}}Numbers of columns to be stored.{p_end}

{synopt:{opt tabstat:s(statistics-names)}}Names of columns to be stored.
For example, .{p_end}

{p2colset 10 23 22 12}{...}
{p2col :{marker stats}Statistic}Description{p_end}
{p2line}
{p2col :{bf:b}}Estimated margins{p_end}
{p2col :{bf:lb}}Lower bound of confidence interval{p_end}
{p2col :{bf:ub}}Upper bound of confidence interval{p_end}
{p2col :{bf:p}}p-value for test margin is 0{p_end}
{p2col :{bf:se}}Standard error of margin{p_end}
{p2col :{bf:z}}z-value{p_end}
{p2col :{bf:df}}Degrees of freedom for test{p_end}
{p2col :{bf:crit}}Critical value for test{p_end}
{p2col :{bf:eform}}{p_end}
{p2line}

{p2colset 8 30 32 12}{...}

{synopt:{opt noomit}}Do not save omitted columns (e.g., o.).{p_end}

{synopt:{opt dropcolm:iss(x)}}Exclude columns that are all missing.{p_end}

{synopt:{opt droprowm:iss(x)}}Exclude rows that are all missing.{p_end}

{synopt:{opt rows(numeric-list)}}List of rows to save. Default is all.{p_end}


{syntab:{ul:How to name rows and columns}}

{synopt:{opt colstub(column-stub)}}Place this string in front of 
column names.{p_end}

{synopt:{opt coleq:nm(string)}}Use this string to as column equation name.
{p_end}

{synopt:{opt out:come(integer)}}Add this number to the end of the column
name for use with categorical outcomes.{p_end}

{synopt:{opt cnum:ber}}Name the columns simply by their number.{p_end}

{synopt:{opt rowstub(string)}}Place this string in front of current row
names.{p_end}

{synopt:{opt roweq:nm(string)}}Use this string to as row equation name.
{p_end}

{synopt:{opt rnum:ber)}}Name the rows simply by their number.{p_end}


{syntab:{ul:Generating variables generated and saving matrices}}

{synopt:{opt gen:erate(colunn-numbers)}}Variables are generated from the 
columns in column-numbers; _all selects all columns. 
With option {cmd: transpose}, matrix is transposed so that rows are
used to create variables.{p_end}

{synopt:{opt genstub(stub)}}.Variables are named gstub+column-name.{p_end}

{synopt:{opt out:come(integer)}}Add this number to the end of the column
name for use with categorical outcomes.{p_end}

{synopt:{opt save(new-matrix)}}The current matrix is saved as matrix 
new-matrix.{p_end}

{synopt:{opt mout:come(integer)}}The integer is added to the end of the matrix
name. Useful when outcomes() is used with {cmd:margins}.
{p_end}


{syntab:{ul:How to save the matrix}}

{synopt:{opt long}}If a matrix is added to an existing matrix, place the
    new information below the existing information.{p_end}
{synopt:{opt wide}}If a matrix is added to an existing matrix, place the
    new matrix to the right of the existing matrix.{p_end}
{synopt:{opt atleft}}Place the r(at) matrix to the left of the r(table)
matrix.{p_end}
{synopt:{opt atright}}Place the r(at) matrix to the right of the r(table)
matrix.{p_end}


{syntab:{ul:How to list the matrix}}

{synopt:{opt list}}List the matrix. Otherwise the matrix is saved, but
not listed.{p_end}

{synopt:{opt title(string)}}Title used when listing matrix.{p_end}

{synopt:{opt pre:view}}Preview the changes to the collect matrix but do
    not retain the changes. This lets you check what {cmd:statout}
    options do or lets list a matrix using the row and column
    options without modifying the original collect matrix.{p_end}

{synopt:{opt title(string)}}Title used when listing matrix.{p_end}

{synopt:{opt tran:spose}}Transpose the matrix before listing. The
original matrix is not change.{p_end}

{synopt:{opt f:ormat(string)}}The format used for listing
    the matrix. For example, {bf:format(%10.2f)}.
    See {help format:format} for details.{p_end}

{synopt:{opt wid:th(integer)}}The column width for
    listing the matrix. For example, to
    list each column with a width of 12, {bf:width(12)}.{p_end}

{synopt:{opt dec:imals(integer)}}The number of decimal digits
    used when the matrix is listed. For example, to
    list with three digits, {bf:decimals(3)}.{p_end}


{marker examples}{...}
{title:Examples}

    {hline}

{pstd}{bf:}{p_end}

{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}

    {hline}

{pstd}{bf:}{p_end}

{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}

    {hline}

{pstd}{bf:}{p_end}

{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}

    {hline}

{pstd}{bf:}{p_end}

{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}
{phang2}{p_end}

    {hline}


{title:Also see}

{pstd}
Manual: {hi:[R] margins}
INCLUDE help mp_footer
